/** @file entrymenu.h
 *  @brief Gg[j[NXwb_
 *
 *  @author yasufuku
 *  @date 2011/01
 *  @version 0.10
 *
 *  Copyright(C) 2011 Kensuke Yasufuku
 */
#ifndef _ENTRY_MENU_H_
#define _ENTRY_MENU_H_

#include "include.h"
#include "task.h"
#include "font.h"
#include "scene.h"
#include "camera.h"
#include "sprite.h"

using namespace::pge;

class EntryMenu : public Task
{
private:
	Scene  * m_pScene;
	Font   * m_pMenuFont;
	Font   * m_pInfo;
	int      m_nMenu;
	int      m_nCurrentMenu;
	bool     m_bDispMenu;
	Sprite * m_pBackground;

	int		 m_nEnter;
	int      m_nTimer1;
	int      m_nTimer2;

protected:
	virtual int OnInit();	///< ^XN
	virtual int OnMain();	///< ^XNC
	virtual int OnKill();	///< ^XN
	
public:
	static Task * Create( Task * pParent, int nPriority = 0 );
	EntryMenu();
	virtual ~EntryMenu();
};

struct MenuItem {
	char * pszName;
	Task * (*CreateTaskFunc)( Task * pParent );
	Task * pTask;
};

#endif // _ENTRY_MENU_H_
