#ifndef _SIMPLE_CD_H_
#define _SIMPLE_CD_H_

/** @file simple_cd.h
 *  @brief OpenDynamicEngine𗘗pȈՏՓ˔NXwb_
 *
 *  @author yasufuku
 *  @date 2011/01
 *  @version 0.10
 *
 *  Copyright(C) 2011 Kensuke Yasufuku
 */
#include <ode/ode.h>
#include "include.h"
#include "vector.h"

struct ArchModel;
struct WalkthroughInfo;

class SimpleCD
{
	//==============================================
	// oϐ
	//==============================================
private:
	float           m_fImpulse1;
	float           m_fImpulse2;
	float           m_fFPSRatio;
	
	dWorldID		m_odeWorld;
	dSpaceID		m_odeSpace;
	dJointGroupID	m_odeContactGroup;
	
	dGeomID			m_odeBuilding;
	dTriMeshDataID	m_odeBuildingTriData;

	dBodyID			m_odeSphereBody;
	dGeomID			m_odeSphereGeom;

	float			m_fSphereRadius;
	Vector			m_vPoint;
	Vector			m_vForce;
	Vector			m_vTorque;
	bool			m_bGround;

	float           m_fEyeHeight;
	float           m_fCollisionHeight;

	//==============================================
	// o֐
	//==============================================
protected:
	int InitODE();
	int MakeCollisionData( WalkthroughInfo * pInfo );

public:
	SimpleCD();
	virtual ~SimpleCD();

	int  Init( WalkthroughInfo * m_pInfo );
	void Destroy();
	void Update();
	const Vector & GetPoint();
	const Vector & GetFootPoint();

	void ResetForce();
	void MoveToRight( float sphereDir );
	void MoveToLeft( float sphereDir );
	void MoveForward( float sphereDir );
	void MoveBackward( float sphereDir );
	void Rise();
	void Fall();
	
	static void NearCallback( void * data, dGeomID o1, dGeomID o2 ); 
};

#endif //_SIMPLE_CD_H_
