#ifndef _WALK_SIM_H_
#define _WALK_SIM_H_

/** @file walk_sim.h
 *  @brief EH[NX[NXwb_
 *
 *  @author yasufuku
 *  @date 2011/01
 *  @version 0.10
 *
 *  Copyright(C) 2011 Kensuke Yasufuku
 */
#include "scene.h"
#include "camera.h"
#include "light.h"
#include "model.h"
#include "mathlib.h"
#include "simple_cd.h"
#include "font.h"

using namespace::pge;

//===============================================================
// ݒf[^`
//===============================================================
struct ArchModel
{
	ModelData * pDspModel; // \f
	ModelData * pColModel; // Փ˔胂f
};

struct WalkthroughInfo
{
	float       radius;			// 蔼a
	float       eyeHeight;		// _̍
	Vector      pos;			// ʒu
	float       ry;				// 
	int         nArchModel;		// zf
	ArchModel * pArchModel;		// zff[^
	float       fImpulse1;		//
	float		fImpulse2;		//
	bool		bCulling;		// \f̃JOݒ
};

//===============================================================
// NX`
//===============================================================
/**
 *	  @brief WalkSimNX
 *
 *    EH[NX[V~[VNX
 */
class WalkSim : public Task
{
	//==============================================
	// oϐ
	//==============================================
private:
	WalkthroughInfo * m_pInfo;
	SimpleCD		  m_CD;

	// ՃJ̏ʒu
	float	m_fDist;
	float	m_fTheta;
	float	m_fPhi;
	
	Scene  * m_pScene;
	Camera * m_pCamera;
	Light  * m_pLight;
	Model  * m_pFPerson;
	Model  * m_pLady;
	bool	 m_bGround;

	Scene  * m_pScene2D;
	Camera * m_pCamera2D;
	Font   * m_pHelp;
	bool     m_bDispHelp;
	
	int		 m_nCameraMode;  // 0:1st 1:3st
	float	 m_fFPSRatio; // 601Ƃčl
	float	 m_fNeckPhi;
	float	 m_fNeckTheta;
	float	 m_fSphereDir;

	//==============================================
	// o֐
	//==============================================
protected:
	//----------------------------------------------
	// bZ[W
	//----------------------------------------------
	virtual int OnInit();		// ^XN
	virtual int OnMain();		// ^XNC
	virtual int OnKill();		// ^XN

	int MovePerson();
	int UpdateFPCamera();
	int UpdateTPCamera();

public:
	static Task * Create( Task * pParent, int i );
	static Task * Create( Task * pParent );
	WalkSim( int i);
	virtual ~WalkSim();
};

#endif //_WALK_SIM_H_
