/** @file element.h
 *  @brief ElementNXwb_
 *
 *  @author yasufuku
 *  @date 2004/07
 *  @version 0.10
 *
 *  Copyright(C) 2004 Kensuke Yasufuku
 */

//-------------------------------------------------------------------
//	_OV[̍\vfƂȂ̂́AElementNXh
//
//		Element ---> Scene
//		        +--> Camera
//              +--> Light
//              +--> Model			etc...
//-------------------------------------------------------------------
#ifndef _ELEMENT_H_
#define _ELEMENT_H_

//====================================================================
// CN[h
//====================================================================
#include "task.h"
#include "color.h"
#include "vector.h"
#include "matrix.h"

//====================================================================
// 萔
//====================================================================
#define ELEMENT_COLOR_OVERWRITE		BIT1

//====================================================================
// NX`
//====================================================================
/**
 *  @brief ElementNX
 *
 *	_OV[̍\vf(Element)NX
*/
class Element : public Task
{
	//==============================================
	// o
	//==============================================
public:
	// TRS
	Vector t;
	Vector r;
	Vector s;
	Matrix m;
	
protected:
	bool  m_bDisp;
	u32   m_unFlag;
	Color m_Color;
	//==============================================
	// o֐
	//==============================================
protected:
	//----------------------------------------------
	// bZ[W
	//----------------------------------------------
	virtual int Receive( TaskMessage * pMessage );	///< bZ[WfBXpb`
	virtual int OnInit();							///< ^XN
	virtual int OnMain();							///< ^XNC
	
	virtual int OnUpdate();							///< XV
	virtual int OnRender();							///< _O
	virtual int OnResize();							///< _O
	
	virtual int OnUpdateChildren();

public:
	/// ֐
	static Element * Create( Element * pParent, int nPriority );
	Element();									///< RXgN^
	virtual ~Element();							///< fXgN^

	//----------------------------------------------
	// fobOp
	//----------------------------------------------
	void DispElementList();		///< Gg\
	void SetDisp( bool bDisp ) { m_bDisp = bDisp; }
	void SetColor( const Color & c ) { m_unFlag |= ELEMENT_COLOR_OVERWRITE; m_Color = c; }
	void ResetColor() { m_unFlag &= ~ELEMENT_COLOR_OVERWRITE; }
	const Color & GetColor(){ return m_Color; }
	
};

#endif //_ELEMENT_H_
