/** @main_ogl.cpp
 *  @brief OpenGLpC֐ъe
 *
 *  @author yasufuku
 *  @date 2010/12
 *  @version 0.10
 *
 *  Copyright(C) 2010 Kensuke Yasufuku
 */
#include "include.h"
#include "main_loop.h"
#include "sys_config.h"
#include "entrymenu.h"

extern SystemConfig sc;
//====================================================================
// NX`
//====================================================================
//---------------------------------------------------------------
// RXgN^
//---------------------------------------------------------------
MainLoop::MainLoop()
{
	m_pRootTask = NULL;
#ifdef ENABLE_SET_FPS
	m_bDispFPS = false;
#endif
	m_bPause   = false;
}

//---------------------------------------------------------------
// fXgN^
//---------------------------------------------------------------
MainLoop::~MainLoop()
{
	// Еt
	m_pRootTask->DispTaskList();
	m_pRootTask->Destroy();
}

//---------------------------------------------------------------
// Jn
//---------------------------------------------------------------
int MainLoop::Start(  int argc, char ** argv )
{
	PRINTF("MainLoop START\n");
		
	// RootTask
	m_pRootTask = RootTask::Create();
	// View̐
	View::Create( m_pRootTask, TP_VIEW );
	// MouseTask
	m_pMouse = Mouse::Create( m_pRootTask );
	// KeyboardTask
	m_pKeyboard = Keyboard::Create( m_pRootTask );
	
	// EntryMenu
	EntryMenu::Create( m_pRootTask );
		
	return 0;
}

//---------------------------------------------------------------
// XV
//---------------------------------------------------------------
int MainLoop::Update()
{
	if( ! m_bPause ) {
		m_pRootTask->Call( &g_TMMain );
	} else {
		///m_pController->Call( &g_TMMain );
		//m_pMouse->Call( &g_TMMain );
	}

	//if( Controller::Trigger( PAD_DEBUG ) ) {
	//	m_bDispFPS = ~(int)m_bDispFPS & (bool)0x01;
	//}

	//if( Controller::Trigger( PAD_START ) ) {
	//	m_bPause = ~(int)m_bPause & (bool)0x01;
	//}
	return 0;
}

//---------------------------------------------------------------
// `
//---------------------------------------------------------------
int MainLoop::Draw()
{
	glClearColor( sc.afBackGroundColor[0],
				  sc.afBackGroundColor[1],
				  sc.afBackGroundColor[2],
				  sc.afBackGroundColor[3] );

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
	glLoadIdentity();
	View::Render();
	glutSwapBuffers();

	return 0;
}
