/** @file view.cpp
 *  @brief \NX\[X
 *
 *  @author yasufuku
 *  @date 2010/12
 *  @version 0.10
 *
 *  Copyright(C) 2010 Kensuke Yasufuku
 */
#include "view.h"

//====================================================================
// statico
//====================================================================
View * View::s_pSelf = NULL;

//====================================================================
// ViewNXo֐`
//====================================================================
//--------------------------------------------------------------
// 
//--------------------------------------------------------------
/**
 *	@param	pParent		e^XN( ʏRootTask )
 *	@param	nPriorit	Dx
 *	@retval				ꂽViewNX|C^
 */
View * View::Create( Task * pParent, int nPriority )
{
	if( s_pSelf == NULL && pParent ) {
		s_pSelf = NEW View;
		s_pSelf->Init( pParent, nPriority );
	}
	
	return s_pSelf;
}

//--------------------------------------------------------------
// RXgN^
//--------------------------------------------------------------
View::View()
{
	SetName("View(SceneRoot)");
	m_pRootElement = NULL;
}

//--------------------------------------------------------------
// fXgN^
//--------------------------------------------------------------
View::~View()
{
}

//--------------------------------------------------------------
// 
//--------------------------------------------------------------
/**
 *	RootElement
 *	@retval TaskResult
 */
int View::OnInit()
{
	// [gGg
	m_pRootElement = NEW Element;
	m_pRootElement->Init( NULL, 0 );
	m_pRootElement->SetName( "RootElement" );

	return TR_OK;
}

//--------------------------------------------------------------
// C
//--------------------------------------------------------------
/**
 *	[gGg炻̎qɍXVbZ[W𑗂
 *	@retval TaskResult
 */
int View::OnMain()
{
	// [gGgXV
	m_pRootElement->Call( &g_TMUpdate);

	return TR_OK;
}

//--------------------------------------------------------------
// 
//--------------------------------------------------------------
/**
 *	[gGgĂ
 *	@retval TaskResult
 */
int View::OnKill()
{
	// [gGg
	m_pRootElement->Destroy();

	// g̏
	return TR_OK;
}

//--------------------------------------------------------------
// [gGg擾
//--------------------------------------------------------------
Element * View::GetRoot()
{
	if( s_pSelf ) {
		return s_pSelf->m_pRootElement;
	} else {
		return NULL;
	}
}

//--------------------------------------------------------------
// _O
//--------------------------------------------------------------
/**
 *	[gGg炻̎qɃ_ObZ[W𑗂
 */
void View::Render()
{
	// _O
	if( s_pSelf ) {
		s_pSelf->m_pRootElement->Call( &g_TMRender);
	}
}

//--------------------------------------------------------------
// EBhETCỸTCY
//--------------------------------------------------------------
/**
 *	[gGg炻̎qɃTCYbZ[W𑗂
 */
void View::Resize()
{
	// TCY
	if( s_pSelf ) {
		s_pSelf->m_pRootElement->Call( &g_TMResize);
	}
}

//--------------------------------------------------------------
// GgXg\
//--------------------------------------------------------------
void View::DispElementList()
{
	PRINTF("--------------------------------\n");
	PRINTF("  Element Tree\n");
	PRINTF("--------------------------------\n");

	m_pRootElement->DispChildren();

	PRINTF("--------------------------------\n");
}
