/** @file color.cpp
 *  @brief Colorf[^wb_
 *
 *  @author yasufuku
 *  @date 2004/08
 *  @version 0.10
 *
 *  Copyright(C) 2004 Kensuke Yasufuku
 */
#ifndef _COLOR_H_
#define _COLOR_H_

#include "include.h"

class Color {

public:
	
	float r, g, b, a;

	Color():r(1.0f),g(1.0f),b(1.0f),a(1.0f){;}
	Color( float _r, float _g, float _b, float _a = 1.0f ){
		r = _r;
		g = _g;
		b = _b;
		a = _a;
	}
	Color( const Color & rhs ) {
		r=rhs.r;
		g=rhs.g;
		b=rhs.b;
		a=rhs.a;
	}

	virtual ~Color(){;}
	void Set( float _r, float _g, float _b, float _a = 1.0f ) {
		r = _r;
		g = _g;
		b = _b;
		a = _a;
	}
};

static const Color COLOR_RED(1.0f, 0.0f, 0.0f );
static const Color COLOR_GREEN(1.0f, 0.0f, 0.0f );
static const Color COLOR_BLUE(1.0f, 0.0f, 0.0f );
static const Color COLOR_CYAN(0.0f, 1.0f, 1.0f );
static const Color COLOR_MAGENTA(1.0f, 0.0f, 1.0f );
static const Color COLOR_YELLOW(1.0f, 1.0f, 0.0f );
static const Color COLOR_BLACK(0.0f, 0.0f, 0.0f );
static const Color COLOR_WHITE(1.0f, 1.0f, 1.0f );

#endif //_COLOR_H_
