/** @file light.cpp
 *  @brief LightNXCvg
 *
 *  @author yasufuku
 *  @date 2005/01
 *  @version 0.10
 *
 *  Copyright(C) 2004 Kensuke Yasufuku
 */
#include "light.h"
#include "scene.h"

//===============================================================
// 萔
//===============================================================
//===============================================================
// LightNXo֐`
//===============================================================
//---------------------------------------------------------------
// 
//---------------------------------------------------------------
Light * Light::Create( Element * pParent, int nPriority )
{
	Light * pLi = NEW Light;
	return (Light *)pLi->Init( pParent, nPriority );
}

Light * Light::Create( Element * pParent, const Vector & dir, int nPriority )
{
	Light * pLi = NEW Light;
	pLi->m_Dir = dir;
	return (Light *)pLi->Init( pParent, nPriority );
}

//---------------------------------------------------------------
// RXgN^
//---------------------------------------------------------------
Light::Light()
{
	SetName("Light");

	m_nType = DIRECTIONAL;
	m_Pos.Set( 0.0f, 0.0f, 0.0f );
	m_Dir.Set( 0.0f, 0.0f, 0.0f, 0.0f ); // w = 0.0fɂĂKv
	m_Intensity.Set( 1.0f, 1.0f, 1.0f );
	
#ifdef _DEBUG_LIGHT_
	m_pArrow = NULL;
#endif
}

//---------------------------------------------------------------
// fXgN^
//---------------------------------------------------------------
Light::~Light()
{
}

//---------------------------------------------------------------
// 
//---------------------------------------------------------------
int Light::OnInit()
{
#ifdef _DEBUG_LIGHT_
	m_pArrow = pge::Arrow::Create( (Element *)m_pParent, m_Dir, ZERO_VECTOR, COLOR_YELLOW );
#endif
	return TR_OK;
}

//---------------------------------------------------------------
// XV
//---------------------------------------------------------------
int Light::OnUpdate()
{
	return 0;
}

//---------------------------------------------------------------
// _O
//---------------------------------------------------------------
int Light::OnRender()
{
	// VF[_[ΉɂJgV[ɃCgZbg邾
	Scene::SetLightPtr( this ); // 1ΉĂ܂񥥥B
	return TR_OK;
}

//---------------------------------------------------------------
// _̌ʒuZbg
//---------------------------------------------------------------
void Light::SetPosition( const Vector & pos )
{
	m_nType = POINT;
	m_Pos   = pos;
}

//---------------------------------------------------------------
// šZbg
//---------------------------------------------------------------
void Light::SetDirection( const Vector & dir )
{
	m_nType = DIRECTIONAL;
	m_Dir   = dir;
	m_Dir.w = 0.0f;
	
#ifdef _DEBUG_LIGHT_
	m_pArrow->SetPoints(m_Dir, ZERO_VECTOR );
#endif
}
