/** @file light.h
 *  @brief LightNXwb_
 *
 *  @author yasufuku
 *  @date 2011/02
 *  @version 0.10
 *
 *  Copyright(C) 2004-2011 Kensuke Yasufuku
 */
#ifndef _LIGHT_H_
#define _LIGHT_H_

#include "include.h"
#include "vector.h"
#include "color.h"
#include "element.h"
#include "primitive.h"

//#define _DEBUG_LIGHT_

/**
 *  @brief LightNX
 *
 *	NX
 *   VF[_[ŃCg̐͂PΉĂȂB
 */
class Light : public Element
{
private:
	enum {
		DIRECTIONAL = 0,		// s()
		POINT		= 1,		// _
	};
	int         m_nType;
	Vector      m_Pos;
	Vector		m_Dir;
	Color       m_Intensity;
	
#ifdef _DEBUG_LIGHT_
	pge::Arrow * m_pArrow; // Cg\
#endif

protected:
	virtual int OnInit();
	virtual int OnUpdate();
	virtual int OnRender();

public:
	static Light * Create( Element * pParent, int nPriority = TP_LIGHT );
	static Light * Create( Element * pParent, const Vector & dir, int nPriority = TP_LIGHT );
	Light();
	virtual ~Light();
	void   SetPosition( const Vector & pos );
	void   SetDirection( const Vector & dir );
	void   Intensity( const Color & i ) { m_Intensity = i; }
	const Vector & GetDir(){ return m_Dir; }
	const Color  & GetIntensity(){ return m_Intensity; }
};

#endif //_LIGHT_H_
