/** @file mesh_base.cpp
 *  @brief MeshBaseNX\[X
 *
 *  @author yasufuku
 *  @date 2004/10
 *  @version 0.10
 *
 *  Copyright(C) 2004 Kensuke Yasufuku
 */
#include "mesh_base.h"

//===============================================================
// MeshBaseNXo֐`
//===============================================================
//---------------------------------------------------------------
// RXgN^
//---------------------------------------------------------------
MeshBase::MeshBase()
{
	m_pData = NULL;
	m_nVFmt = VF_T2F_N3F_P3F;
	m_nReference    = 0;
	m_paMaterialTbl = NULL;
	m_unShader = 0;
	m_paShaderList = NULL;
	m_bColor = false;
	m_Color.Set( 1.0f, 1.0f, 1.0f, 1.0f );
	m_bDrawBody = true;
}

//---------------------------------------------------------------
// fXgN^
//---------------------------------------------------------------
MeshBase::~MeshBase()
{
}


//---------------------------------------------------------------
// _tH[}bgTCY擾
//---------------------------------------------------------------
u32 MeshBase::GetVertexSize( u32 vtxFormat )
{
	static const int VSIZE_P3I1N3UV2x1 = 3+1+3+2;
	static const int VSIZE_P3I1N3UV2x2 = 3+1+3+2+2;

	if( vtxFormat == 0 ) return VSIZE_P3I1N3UV2x1;
	return VSIZE_P3I1N3UV2x2;
}

//---------------------------------------------------------------
// }eAƂɐݒ肳ĂVF[_[ŏdĂ̂
// ̂ŏd̂ȂVF[_[Xg쐬Ă
//---------------------------------------------------------------
void MeshBase::MakeShaderList()
{
	u32 i, j;
	ShaderBase * pShader;
	// Ƃ肠NX^[̈ꎞXg
	u32 unMat = m_pData->sCluster;
	ShaderBase ** tmpList = NEW ShaderBase*[unMat];

	for( i=0; i<unMat; i++ ) {
		tmpList[i] = m_paMaterialTbl[m_pData->pCluster[i].sMaterialIndex]->GetShader();
	}

	bool bDipl;
	m_unShader = 0;
	// ŏ̓VF[_[Xg𒲂ׂ
	for( i=0; i<unMat; i++ ) {
		pShader = tmpList[i];
		bDipl = false;
		for( j=0; j<i; j++ ) {
			if( pShader == tmpList[j] ) {
				bDipl = true;
				break;
			}
		}
		if( ! bDipl ) m_unShader++;
	}

	m_paShaderList = NEW ShaderBase*[m_unShader];

	u32 index=0;
	// dĂȂ̂Xgɓo^Ă
	for( i=0; i<unMat; i++ ) {
		pShader = tmpList[i];
		bDipl = false;
		for( j=0; j<i; j++ ) {
			if( pShader == tmpList[j] ) {
				bDipl = true;
				break;
			}
		}
		if( ! bDipl ) m_paShaderList[index++] = pShader;
	}
	

	delete [] tmpList;
}

//---------------------------------------------------------------
// Q
//---------------------------------------------------------------
MeshBase * MeshBase::Reference()
{
	m_nReference++;
	return this;
}

//---------------------------------------------------------------
// J
//---------------------------------------------------------------
void MeshBase::Release()
{
	if( m_nReference > 0 ) {
		m_nReference--;
	}

	if( m_nReference == 0 ) {
		delete this;
	}
}
