/** @file model_data.h
 *  @brief ff[^\̃wb_
 *
 *  @author yasufuku
 *  @date 2004/07
 *  @version 0.10
 *
 *  Copyright(C) 2004 Kensuke Yasufuku
 */
#ifndef _MODEL_DATA_
#define _MODEL_DATA_

#include "include.h"
#include "color.h"
#include "tex_data.h"
#include "mathlib.h"

enum {
	VF_T2F_N3F_P3F = 0,
	VF_T2F_C3F_P3F,
	VF_T2F_P3F,
};

//==========================================================
// ff[^\
//==========================================================
//
// ModelData -> MeshData -> ClusterData
//
//==========================================================

//----------------------------------------------------------
// }eAf[^\
//----------------------------------------------------------
/**
 *
 */
typedef struct _MaterialData {

	Color	specular;			///< XyL
	Color	diffuse;			///< ft[Y
	Color	ambient;			///< ArGg


	s16		  sTexture;	///< eNX`
	TexHeader * pTexHeader; ///< eNX`wb_z
#if 0
	TexBlendData  * pTexBlend;
#endif

#if 0
	// ep[^(}bvAov}bvA@}bv)
#endif
	u8 bNoLight;
} MaterialData;

//----------------------------------------------------------
// NX^f[^\
//----------------------------------------------------------
/**
 *	}eAPʂ̃bVf[^
 */
typedef struct _ClusterData {

	u32		  unVtxFormat;		///< _tH[}bg
	s16       sVtxArrayIndex;	///< _zIndex
	s16       sMaterialIndex;	///< }eAzIndex

	int       nVtxBuffer;		///< _obt@TCY
	float   * pVtxBuffer;		///< _obt@|C^
	int       nPrimType;		///< v~eBu^Cv
	int       nIdxBuffer;		///< CfbNXobt@TCY
	int     * pIdxBuffer;		///< CfbNXobt@|C^
	int       nDuplicatedPos;
	int    ** ppDuplicatedPos;
	int		  nVisEdge;
	int     * pVisEdge;

} ClusterData;

//----------------------------------------------------------
// bVf[^\
//----------------------------------------------------------
/**
 *	bVf[^
 */
typedef struct _MeshData {

	s16				sVArray;	///< _z	
	s16				sCluster;	///< NX^[
	ClusterData *	pCluster;	///< NX^[f[^|C^
	s16            sMaterial;	///< }eA
	MaterialData * pMaterial;	///< }eAf[^z
	
} MeshData;

//----------------------------------------------------------
// {[\
//----------------------------------------------------------
/**
 *	\f[^\
 */
typedef struct _BoneData {
	
	s8	cSibling;	// ZԐڔԍ
	s8	cChild;		// q֐ߔԍ
	
} BoneData;

	
//----------------------------------------------------------
// ff[^\
//----------------------------------------------------------
/**
 *	ff[^
 */
typedef struct _ModelData {
	
	u32			unFlag;			///< tO
	s16			sMesh;			///< bV
	MeshData *	pMesh;			///< bVf[^z

	s16			sBone;			///< {[
	BoneData *	pBone;			///< {[\
	Mtx44 *		pBoneInvMtx;	///< {[̋t}gbNX

	s16			sWeights;		///< EFCg(}`{[)
	s8 *		pWeights;		///< EFCgf[^

	
	
#if 0
	CollisionData * pCollision;
	PhysicsData   * pPhysics;
#endif
	
} ModelData;

//----------------------------------------------------------
// [Vf[^\
//----------------------------------------------------------
/**
 *	[Vf[^
 */
typedef struct _MotionData {

	u32 unFrame;
	u32 unBone;
	TRS * pTRS;
} MotionData;


//----------------------------------------------------------
// Clothf[^\
//----------------------------------------------------------
/**
 *	ClothAj[Vݒf[^()
 */
typedef struct _ClothData {

	int     nVtxArray;
	float * pfVtxArray;
	int   * pnClothMass;
	int   * pnNailMass;
	int   * pnSpringConnectInfo;
	int   * pnNormalInfo;
	
} ClothData;

//----------------------------------------------------------
// Edgef[^\
//----------------------------------------------------------
/**
 *
 */
typedef struct _EdgeData {
	u8  ucIndex;
	u32 unVertexIndex[2];
	u32 unTriangleIndex[2][3];
} EdgeData;

#endif //_MODEL_DATA_
