/** @file shader_base.h
 *  @brief VF[_[x[XNXwb_
 *
 *  @author yasufuku
 *  @date 2011/01
 *  @version 0.10
 *
 *  Copyright(C) 2011 Kensuke Yasufuku
 */
#ifndef _SHADER_BASE_H_
#define _SHADER_BASE_H_

#include "include.h"

/**
 *  @brief ShaderBaseNX
 *
 *  VF[_[x[XNX
*/
class ShaderBase
{
	friend class ShaderManager;	
private:	
	enum {
		RET_LOAD_OK = 0,
		RET_FILE_NOT_FOUND,
		RET_COMPILE_ERROR,
		RET_LINK_ERROR,
	};
	const char * m_pszVsfname;
	const char * m_pszFsfname;
	
	GLuint m_hProgram; // VF[_[vOnh
	
	GLint m_hLocPosition;
	GLint m_hLocNormal;
	GLint m_hLocIndex;
	GLint m_hLocUV0;
	GLint m_hLocUV1;
	GLint m_hLocVColor;

	GLint m_hLocMVPMatrix;
	GLint m_hLocWorldMatrix;
	GLint m_hLocMVMatrix;
	GLint m_hLocProjMatrix;
	GLint m_hLocMatrixList;
	GLint m_hLocEyePos;
	
	GLint m_hLocDiffuse;
	GLint m_hLocAmbient;
	GLint m_hLocSpecular;
	GLint m_hLocColor;

	GLint m_hLocLightsNum;
	GLint m_hLocLightsPos;
	GLint m_hLocLightsDir;
	GLint m_hLocLightsInt;

	GLint m_hLocDiffuseMap;
	GLint m_hLocLightMap;

	
protected:
	ShaderBase( const char * vsfname, const char * fsname ); ///< RXgN^
	virtual ~ShaderBase();				///< fXgN^
	/// [hA[h
	int Load();
	int Unload();
public:
	/// Fill
	void Fill();
	const GLuint Program()           { return m_hProgram;        }

	const GLint LocPosition()        { return m_hLocPosition;    }
	const GLint LocNormal()          { return m_hLocNormal;      }
	const GLint LocIndex()           { return m_hLocIndex;       }

	const GLint LocUV0()             { return m_hLocUV0;         }
	const GLint LocUV1()             { return m_hLocUV1;         }
	const GLint LocVColor()          { return m_hLocVColor;      }

	const GLint LocMVPMatrix()	     { return m_hLocMVPMatrix;   }
	const GLint LocWorldMatrix()     { return m_hLocWorldMatrix; }
	const GLint LocMVMatrix()        { return m_hLocMVMatrix;    }
	const GLint LocProjMatrix()      { return m_hLocProjMatrix;  }
	const GLint LocMatrixList()      { return m_hLocMatrixList;  }
	const GLint LocEyePos()          { return m_hLocEyePos;      }

	const GLint LocDiffuse()         { return m_hLocDiffuse;     }
	const GLint LocAmbient()         { return m_hLocAmbient;     }
	const GLint LocSpecular()        { return m_hLocSpecular;    }
	const GLint LocColor()           { return m_hLocColor;       }
	
	const GLint LocLightsNum()       { return m_hLocLightsNum;   }
	const GLint LocLightsPos()       { return m_hLocLightsPos;   }
	const GLint LocLightsDir()       { return m_hLocLightsDir;   }
	const GLint LocLightsIntensity() { return m_hLocLightsInt;   }

	const GLint LocDiffuseMap()      { return m_hLocDiffuseMap;  }
	const GLint LocLightMap()        { return m_hLocLightMap;    }

	void  PrintInfo();
};

#endif //_SHADER_BASE_H_
