/** @file vector2d.h
 *  @brief 2xNgNXwb_
 *
 *  @author yasufuku
 *  @date 2011/02
 *  @version 0.20
 *
 *  Copyright(C) 2004-2011 Kensuke Yasufuku
 */
#ifndef _VECTOR_2D_H_
#define _VECTOR_2D_H_

#include "include.h"
#include "mathlib.h"

/**
 *	  @brief Vector2DNX
 *
 *    xNgZNX ( x,y,z,w float̂ݑΉ )
 */
class Vector2D
{
public:
	//--------------------------------------------------
	// o
	//--------------------------------------------------
	float x, y;

	//-------------------------------------------------
	// o֐
	//-------------------------------------------------
public:
	Vector2D();
	~Vector2D();

	Vector2D( float fx, float fy );
	Vector2D( const Vector2D & v );

	//-------------------------------------------------
	// Zq
	//-------------------------------------------------
	// zCfbNX
	float		& operator [] ( u32 i );
	const float	& operator [] ( u32 i ) const;
		
	// Z
	Vector2D & operator += ( const Vector2D &v );
	Vector2D & operator -= ( const Vector2D &v );
	
	
	// XJ[{
	Vector2D & operator *= ( float f );
	Vector2D & operator /= ( float f );
	
public:
	void     Set( float x=0.0f, float y=0.0f );	// lZbg
	
	float    Length() const;		// 
	float    LengthSqr() const;		// ̂Q
	bool     IsZero() const;		// [
	bool     IsNearlyZero() const;	// jA[[
	Vector2D & Normalize();			// K

	//-------------------------------------------------
	// Debug
	//-------------------------------------------------
	void     Print();
};

//====================================================================
// 񃁃o֐
//====================================================================

Vector2D Normalized( const Vector2D &v );					// K
float  DotProduct( const Vector2D &a, const Vector2D &b);	// 
void   SwapVector( Vector2D &a, Vector2D &b );				// Swap
bool   NearlyEquals( const Vector2D &a, const Vector2D &b, float r );
float  GetAngle( const Vector2D &a, const Vector2D &b );		// px
float  GetCosTheta( const Vector2D &a, const Vector2D &b );	// cos
int Sign( const Vector2D & v1, const Vector2D & v2 );
// Ȃ̔
bool operator == ( const Vector2D &a, const Vector2D &b );
bool operator != ( const Vector2D &a, const Vector2D &b );

// ]
Vector2D operator - ( const Vector2D &a );
Vector2D operator + ( const Vector2D &a, const Vector2D &b );
Vector2D operator - ( const Vector2D &a, const Vector2D &b );
Vector2D operator * ( const Vector2D &v, float f );
Vector2D operator * ( float f, const Vector2D &v );
Vector2D operator / ( const Vector2D &v, float f );

// 
float operator * ( const Vector2D &a, const Vector2D &b );

//====================================================================
// 񃁃o֐
//====================================================================
static const Vector2D ZERO_VECTOR2D( 0.0f, 0.0f );

#endif //_VECTOR_2D_H_
