/** @file mouse.h
 *  @brief MouseNXwb_
 *
 *  @author yasufuku
 *  @date 2011/02
 *  @version 0.10
 *
 *  Copyright(C) 2004-2011 Kensuke Yasufuku
 */
#ifndef _MOUSE_H_
#define _MOUSE_H_

#include "include.h"
#include "task.h"

//====================================================================
// 萔`
//====================================================================
#define MOUSE_L_BUTTON			0x01
#define MOUSE_R_BUTTON			0x02
#define MOUSE_M_BUTTON			0x04


//====================================================================
// NX`
//====================================================================
/**
 *	  @brief MouseNX
 *		GLUT𗘗p
 */
class Mouse : public Task
{
private:
	static Mouse * s_pSelf;		///< VOg
	bool m_bDrag;				///< hbO
	bool m_bMove;
	int m_nX, m_nY;				///< hbOĂꍇ̍W
	int m_nPrevX, m_nPrevY;		///< hbOĂꍇ̑Ot[W
	int m_nClickX, m_nClickY;	///< NbNW
	u32 m_unClick;				///< NbN{^
	u32 m_unDrag;

	int m_nMoveX, m_nMoveY;			
	int m_nPrevMoveX, m_nPrevMoveY;
	int m_nMoveDX, m_nMoveDY;
	
	int m_nDragDX, m_nDragDY;
	
	bool m_bFPSMode;
	
protected:
	Mouse();					///< RXgN^
	virtual ~Mouse();			///< fXgN^

	//----------------------------------------------
	// bZ[W
	//----------------------------------------------
	virtual int OnInit();		///< 
	virtual int OnMain();		///< ^XNC
	virtual int OnKill();		///< 
	
public:
	/// ֐
	static Mouse * Create( Task * pParent );
	/// CX^X擾
	static Mouse * GetSelf(){ return s_pSelf; }
	
	static int Click( u32 button );	///< NbNׂ
	static int Drag ( u32 button );	///< hbOׂ

	/// W擾
	static int GetPoint( int & x, int & y );

	/// hbÖړʎ擾
	static int GetDrag(  int & x, int & y );
	/// ړʎ擾
	static int GetMove(  int & x, int & y );
	/// NbNW擾
	static int GetClickPoint( int & x, int & y );

	void CallBackClick( int button, int stat, int x, int y );
	void CallBackDrag( int x, int y );
	void CallBackMove( int x, int y );
	static void SetFPSMode( bool bFPS ) {
		s_pSelf->m_bFPSMode = bFPS;
		if( bFPS ) {
			glutSetCursor(GLUT_CURSOR_NONE);
		} else {
			glutSetCursor(GLUT_CURSOR_INHERIT);
		}
	}
};

#endif //_MOUSE_H_
